
/********************************************************************************
Description :  Խ 
			  Խ ȣ  ܼ Ű 
	
Writer : 	woo choul_woong 
Date    : 	2004.10.13
*********************************************************************************/
IF Object_ID('Notify') IS NOT NULL
	DROP TABLE Notify
GO

CREATE TABLE Notify 
(No int IDENTITY PRIMARY KEY  NONCLUSTERED 
	,PNo int NULL
	,RootNo int
	,Lvl tinyint NOT NULL DEFAULT(0) 
	,Hierarchy varchar (100) NULL 
	,Title nvarchar (100) NOT NULL)
GO
CREATE CLUSTERED INDEX IXCL_Notify    ON Notify(RootNo) 
GO
CREATE INDEX IX_Notify_Hierarchy ON Notify(Hierarchy) 
GO

IF Object_ID('tr_Notify_i') IS NOT NULL
	DROP TRIGGER tr_Notify_i
GO
CREATE TRIGGER tr_Notify_i ON Notify FOR INSERT
AS

IF @@ROWCOUNT  > 1
    BEGIN 
        RAISERROR(' Ǿ ִ Ϳ  մϴ.',16,1)
        ROLLBACK TRAN
        RETURN
    END

DECLARE @Hierarchy AS varchar(100)

UPDATE t1
    SET lvl =  CASE  WHEN t1.PNo IS NULL THEN 0  ELSE t2.lvl + 1 END,
            @Hierarchy = Hierarchy 
		  =   CASE  WHEN t1.PNo IS NULL THEN  '' ELSE t2.hierarchy  END 
                  + RIGHT('000000' + CONVERT(varchar,t1.No ), 6) + '.'    ,
 	    RootNo = CONVERT(int, LEFT(@Hierarchy, 6))              
    FROM Notify AS t1
            JOIN inserted AS i 
                 ON i.No = t1.No 
            LEFT OUTER JOIN notify AS t2 
                 ON t1.PNo = t2.No
GO

INSERT Notify(Title, PNo) VALUES('', NULL)
INSERT Notify(Title, PNo) VALUES('', 1)
INSERT Notify(Title, PNo) VALUES('', 2)
INSERT Notify(Title, PNo) VALUES('', 3)
INSERT Notify(Title, PNo) VALUES('', NULL)
INSERT Notify(Title, PNo) VALUES('', 5)
INSERT Notify(Title, PNo) VALUES('', 6)
INSERT Notify(Title, PNo) VALUES('', NULL)

INSERT Notify(Title, PNo) VALUES('ű', 2)
INSERT Notify(Title, PNo) VALUES('New', 5)
GO
SELECT * FROM Notify ORDER BY  RootNo DESC, Hierarchy ASC
GO
/********************************************************************************
Description : Character Set̳ Sort Type    Ȯ
	
Writer : 	woo choul_woong 
Date    : 	2004.10.13
*********************************************************************************/
-- ׽Ʈ
SELECT ASCII('0')
SELECT ASCII('A')
SELECT ASCII('Z')
SELECT ASCII('a')
SELECT ASCII('z')

IF Object_ID('test') IS NOT NULL
	DROP TABLE test
GO
CREATE TABLE test (
	seq int NULL ,
	chr char(1) , --COLLATE Korean_Wansung_CI_AS NOT NULL ,
	chrb char(1) COLLATE Korean_Wansung_BIN NULL 
	) 
GO

declare @i int
set @i = 1
while @i < 254
	begin
		insert into test values(@i, char(@i),  char(@i))
		set @i = @i + 1
	end

SELECT * From test order by 2
SELECT * From test order by 3



/********************************************************************************
Description :  Խ 
			   Խ ȣ    ڷ Ͽ óϱ
			  NotifyNo ä ̺ 	
	
Writer : 	woo choul_woong 
Date    : 	2004.10.13
*********************************************************************************/

IF Object_ID('Notify') IS NOT NULL
	DROP TABLE Notify
GO
IF Object_ID('NotifyNo') IS NOT NULL
	DROP TABLE NotifyNo
GO
IF Object_ID('up_GetNotifyNo') IS NOT NULL
	DROP PROC up_GetNotifyNo
GO
IF Object_ID('up_Notify_New') IS NOT NULL
	DROP PROC up_Notify_New
GO

CREATE TABLE Notify 
	(No int NOT NULL PRIMARY KEY  NONCLUSTERED 
	,PNo int NULL
	,RootNo int
	,Lvl tinyint NOT NULL DEFAULT(0) 
	,Hierarchy varchar (100) NULL 
	,Title varchar (500) NOT NULL)
GO

CREATE TABLE NotifyNo
	(No int PRIMARY KEY)
GO

CREATE PROC up_GetNotifyNo
	@No int OUTPUT
AS
UPDATE NotifyNo SET @No = No = No + 1 
IF @@RowCount = 0 
	BEGIN
		SET @No = 1
     		INSERT INTO NotifyNo(No) VALUES(@No)
	END
GO

CREATE PROC up_Notify_New
	 @PNo int 
	,@RootNo int
	,@Lvl tinyint 
	,@Hierarchy varchar (100)  
	,@Title varchar(500) 
	,@WorkType char(1)  --N : New, R : Reply
AS
DECLARE @No int
DECLARE @HierarchyLast char(1)
EXEC up_GetNotifyNo @No OUTPUT

IF @WorkType = 'N'
	BEGIN
		INSERT INTO Notify
			VALUES(@No, @No, @No, 1,    RIGHT('000000' + CONVERT(varchar, @No),6), @Title)
	END
IF @WorkType = 'R'
	BEGIN
	BEGIN TRAN
		SELECT @HierarchyLast = RIGHT(ISNULL(MAX(Hierarchy),'`'),1) -- `  ڰ a 
		FROM Notify WITH (UPDLOCK)
		WHERE Hierarchy LIKE @Hierarchy + '%' AND Lvl = @Lvl + 1	
		
		IF @HierarchyLast >='z'
			BEGIN 
				RAISERROR( 'ϳ ۿ  26 ̻   ϴ.', 16, 1)
				ROLLBACK TRAN
				RETURN 99
			END
		SET @HierarchyLast = CHAR(ASCII(@HierarchyLast)+1)

		INSERT INTO Notify
		VALUES( @No, @PNo, @RootNo, @Lvl + 1, @Hierarchy + @HierarchyLast, @Title )
	COMMIT TRAN
	END

GO

EXEC up_Notify_New 0, 0, 0, '', 'Դϴ', 'N'

EXEC up_Notify_New 1, 1, 1, '000001', 'Դϴ', 'R'

EXEC up_Notify_New 1, 1, 2, '000001a', 'Դϴ', 'R'

EXEC up_Notify_New 3, 3, 1, '000003', 'Դϴ', 'R'

SELECT * FROM Notify



/********************************************************************************
Description :  Խ Է I
			   Խ ȣ   100 Ͽ óϱ
			  ۿ  2ڸ ϵ 	
			  NotifyNo ä ̺ 	
	
Writer : 	woo choul_woong 
Date    : 	2004.10.13
*********************************************************************************/

IF Object_ID('Notify') IS NOT NULL
	DROP TABLE Notify
GO
IF Object_ID('NotifyNo') IS NOT NULL
	DROP TABLE NotifyNo
GO
IF Object_ID('up_GetNotifyNo') IS NOT NULL
	DROP PROC up_GetNotifyNo
GO
IF Object_ID('up_Notify_New') IS NOT NULL
	DROP PROC up_Notify_New
GO

CREATE TABLE Notify 
	(No int NOT NULL PRIMARY KEY  NONCLUSTERED 
	,PNo int NULL
	,RootNo int
	,Lvl tinyint NOT NULL DEFAULT(0) 
	,Hierarchy varchar (100) NULL 
	,Title varchar (500) NOT NULL)
GO
CREATE UNIQUE INDEX Notify_Hierarchy  ON Notify(Hierarchy)
GO

CREATE TABLE NotifyNo
	(No int PRIMARY KEY)
GO

CREATE PROC up_GetNotifyNo
	@No int OUTPUT
AS
UPDATE NotifyNo SET @No = No = No + 1 
IF @@RowCount = 0 
	BEGIN
		SET @No = 1
     		INSERT INTO NotifyNo(No) VALUES(@No)
	END
GO

IF Object_ID('up_Notify_New') IS NOT NULL
	DROP PROC up_Notify_New
GO
CREATE PROC up_Notify_New
	 @PNo int = NULL
	,@RootNo int = NULL
	,@Lvl tinyint = 0 
	,@Hierarchy varchar (100) =''  
	,@Title varchar(500) 
AS
DECLARE @No int
DECLARE @HierarchyLast char(2)
EXEC up_GetNotifyNo @No OUTPUT

--ű 
IF @Hierarchy = '' OR @Hierarchy IS NULL
	BEGIN
		INSERT INTO Notify
			VALUES(@No, @No, @No, 1,    RIGHT('000000' + CONVERT(varchar, @No),6) + 'z' , @Title)
	END
-- 
ELSE
	BEGIN
	BEGIN TRAN
		SET @Hierarchy = LEFT(@Hierarchy, LEN(@Hierarchy) - 1)

		SELECT @HierarchyLast = SUBSTRING(ISNULL(MAX(Hierarchy), '00') , 7 + 2 * (@Lvl - 1), 2 )
		FROM Notify WITH (UPDLOCK)
		WHERE Hierarchy LIKE @Hierarchy + '%' AND Lvl = @Lvl + 1	

		IF @HierarchyLast >='99'
			BEGIN 
				RAISERROR( 'ϳ ۿ  99 ̻   ϴ.', 16, 1)
				ROLLBACK TRAN
				RETURN 99
			END
		SET @HierarchyLast = RIGHT('00'+ CONVERT(varchar, @HierarchyLast+1),2)

		INSERT INTO Notify
		VALUES( @No, @PNo, @RootNo, @Lvl + 1, @Hierarchy + @HierarchyLast + 'z', @Title )
	COMMIT TRAN
	END
GO

EXEC up_Notify_New  0, 0, 0, '', ''
EXEC up_Notify_New  1, 1,1, '000001z', ''
EXEC up_Notify_New  2, 1,2, '00000101z', ''
EXEC up_Notify_New  3, 1,2, '00000101z', ''
EXEC up_Notify_New  0, 0, 0, '',  ''
EXEC up_Notify_New  5, 5,1, '000005z', ''
EXEC up_Notify_New  6, 5,2, '00000501z', ''
EXEC up_Notify_New  0, 0, 0, '',   ''

EXEC up_Notify_New  2, 1, 2, '00000101z',   'ű'
EXEC up_Notify_New  5, 5, 1, '000005z',   'New'

select * from Notify Order by Hierarchy DESC




/********************************************************************************
Description :  Խ Է II
			  ϳ  Է
			   Խ ȣ   100 Ͽ óϱ
			  ۿ  2ڸ ϵ 	
			  NotifyNo ä ̺ 	
	
Writer : 	woo choul_woong 
Date    : 	2004.10.13
*********************************************************************************/

IF Object_ID('Notify') IS NOT NULL
	DROP TABLE Notify
GO
IF Object_ID('NotifyNo') IS NOT NULL
	DROP TABLE NotifyNo
GO
IF Object_ID('up_GetNotifyNo') IS NOT NULL
	DROP PROC up_GetNotifyNo
GO
IF Object_ID('up_Notify_New') IS NOT NULL
	DROP PROC up_Notify_New
GO

CREATE TABLE Notify 
	(No int NOT NULL PRIMARY KEY  NONCLUSTERED 
	,PNo int NULL
	,RootNo int
	,Lvl tinyint NOT NULL DEFAULT(0) 
	,Hierarchy varchar (100) NULL 
	,Title varchar (500) NOT NULL)
GO
CREATE UNIQUE INDEX Notify_Hierarchy  ON Notify(Hierarchy)
GO

CREATE TABLE NotifyNo
	(No int PRIMARY KEY)
GO

CREATE PROC up_GetNotifyNo
	@No int OUTPUT
AS
UPDATE NotifyNo SET @No = No = No + 1 
IF @@RowCount = 0 
	BEGIN
		SET @No = 1
     		INSERT INTO NotifyNo(No) VALUES(@No)
	END
GO

IF Object_ID('up_Notify_New') IS NOT NULL
	DROP PROC up_Notify_New
GO
CREATE PROC up_Notify_New
	 @PNo int = NULL
	,@RootNo int = NULL
	,@Lvl tinyint = 0 
	,@Hierarchy varchar (100) =''  
	,@Title varchar(500) 
AS
DECLARE @No int
DECLARE @HierarchyLast char(2)
EXEC up_GetNotifyNo @No OUTPUT

--ű 
IF @Hierarchy = '' OR @Hierarchy IS NULL
	BEGIN
		INSERT INTO Notify
			VALUES(@No, @No, @No, 1,    RIGHT('000000' + CONVERT(varchar, @No),6) + 'z' , @Title)
	END
-- 
ELSE
	BEGIN
		SET @Hierarchy = LEFT(@Hierarchy, LEN(@Hierarchy) - 1)

		INSERT INTO Notify
		SELECT @No, @PNo, @RootNo, @Lvl + 1
			, @Hierarchy + 
			  (SELECT RIGHT('00'+ 
						CONVERT(varchar, 
							(SUBSTRING(
								ISNULL(MAX(Hierarchy), '00')
							 , 7 + 2 * (@Lvl - 1), 2 ) + 1))
					,2)    + 'z'
			  FROM Notify WITH (UPDLOCK)
			  WHERE Hierarchy LIKE @Hierarchy + '%' AND Lvl = @Lvl + 1	)
			, @Title

		    -- 2727 PRIMARY KEY, UNIQUE     2601 UNIQUE KEY 
   		 IF @@ERROR  = 2627 OR @@ERROR = 2601 
			BEGIN 
				RAISERROR( 'ϳ ۿ  99 ̻   ϴ.', 16, 1)
				ROLLBACK TRAN
				RETURN 99
			END
	END
GO

EXEC up_Notify_New  0, 0, 0, '', ''
EXEC up_Notify_New  1, 1,1, '000001z', ''
EXEC up_Notify_New  2, 1,2, '00000101z', ''
EXEC up_Notify_New  3, 1,2, '00000101z', ''
EXEC up_Notify_New  0, 0, 0, '',  ''
EXEC up_Notify_New  5, 5,1, '000005z', ''
EXEC up_Notify_New  6, 5,2, '00000501z', ''
EXEC up_Notify_New  0, 0, 0, '',   ''

EXEC up_Notify_New  2, 1, 2, '00000101z',   'ű'
EXEC up_Notify_New  5, 5, 1, '000005z',   'New'

select * from Notify Order by Hierarchy DESC



/********************************************************************************
Description :  Խ ȸ -   Ʈ  ȭ

Writer : 	woo choul_woong 
Date    : 	2004.10.13
*********************************************************************************/
IF Object_ID('up_GetNotifyList') IS NOT NULL
	DROP PROC up_GetNotifyList
GO
CREATE   PROC up_GetNotifyList
	  @ActionType char(1) = 'F' 		-- F : First  N : Next  P : Previous  L : Last
	, @Hierarchy varchar(100) =''		-- ȸϰ ִ   Ǵ  No Hierarchy
AS
SET NOCOUNT ON

DECLARE @Query varchar(8000)
DECLARE @MaxRows int			--   ִ  

SELECT @Query = '', @MaxRows = 3

--ù  ȸ
IF @ActionType = 'F' 
BEGIN
	SET @Query = 
	'SELECT TOP ' + STR(@MaxRows + 1) + '
		No, RootNo, Hierarchy, Lvl, Title 
	 FROM Notify  
        Order by  Hierarchy DESC'
    	SELECT @Query
	EXEC (@Query)
	RETURN
    END

--   
--Ȯ    Counting  ʴ  ó
IF @ActionType = 'L'
BEGIN
	SET @Query = '
	    SELECT  * 
	    FROM (
		SELECT TOP ' + STR(@MaxRows) + '
			No, RootNo, Hierarchy, Lvl, Title 
		FROM  Notify 
		ORDER BY Hierarchy ASC ) t
	    ORDER BY Hierarchy DESC'
    	SELECT @Query
	EXEC (@Query)
	RETURN
END

--   
IF @ActionType = 'N' 
BEGIN
	SET @Query = '
	SELECT TOP ' + STR(@MaxRows + 1) +  ' 
		No, RootNo, Hierarchy, Lvl, Title 
		FROM  Notify
	WHERE  Hierarchy < ''' + @Hierarchy + '''
	ORDER BY Hierarchy DESC'
    	SELECT @Query
	EXEC (@Query)
	RETURN 
END

--   
-- 3 ۰ų  ù  ν
-- 3  ù  ٽ ѹ ȣ
IF @ActionType = 'P' 
BEGIN
	SET @Query = '
	SELECT TOP ' + STR(@MaxRows + 1) + ' * 
	FROM (
		SELECT TOP ' + STR(@MaxRows + 1) +  ' 
			No,	RootNo, Hierarchy, Lvl, Title 
		FROM  Notify
		WHERE  Hierarchy > ''' + @Hierarchy + '''
		ORDER BY Hierarchy ASC) t
	ORDER BY Hierarchy DESC '
	SELECT @Query
	EXEC (@Query)
       RETURN 
    END
GO

SELECT * FROM Notify ORDER BY Hierarchy DESC

EXEC up_GetNotifyList
EXEC up_GetNotifyList 'N', '00000502z'
EXEC up_GetNotifyList 'P', '00000501z'
EXEC up_GetNotifyList 'L'

SELECT TOP  4  *        
FROM ( SELECT TOP  4      No, RootNo, Hierarchy, Lvl, Title     
		FROM  Notify    
		WHERE  Hierarchy > '00000501z'    ORDER BY Hierarchy ASC) t       
ORDER BY Hierarchy DESC 

SELECT TOP  4  *        
FROM Notify
WHERE Hierarchy IN
	(SELECT TOP  4 Hierarchy   
		FROM  Notify    
		WHERE  Hierarchy > '00000501z'    ORDER BY Hierarchy ASC)        
ORDER BY Hierarchy DESC 

/********************************************************************************
Description :  Խ ȸ -   Ʈ ִ ȭ

Writer : 	woo choul_woong 
Date    : 	2004.10.13
*********************************************************************************/
IF Object_ID('up_GetNotifyList') IS NOT NULL
	DROP PROC up_GetNotifyList
GO
CREATE   PROC up_GetNotifyList
     @CurrentPageNo int =0
    ,@GotoPageNo int = 1
    ,@Hierarchy varchar(100)		-- ȸϰ ִ   No Hierarchy
AS
SET NOCOUNT ON

DECLARE @Query varchar(8000)
DECLARE @MaxRows int			-- ִ 
DECLARE @MaxPages int 			-- ִ  
DECLARE @PageCnt int				-- ̵    ȣ
DECLARE @DataCnt int 			-- ̺ ü 
DECLARE @LastPageRows int		--   

SELECT @Query = '', @MaxRows = 3, @MaxPages = 20

-- @MaxPages  + 1  @PageCnt ȮϿ RETURN ȯ
-- IF @MaxPages / 20 + 1 = @MaxPages   ̵  61  ִ 81   üũ
-- ̷  ø Notify ü COUNT(*) ȯ
--   Ȯؼ ȯϱ Ʊ  Multi Set ó   

--ù  ȸ
IF @GotoPageNo = 1 
BEGIN
	SET @Query = 
	'SELECT TOP  ' + STR(@MaxRows)  + ' No, RootNo, Hierarchy, Lvl, Title 
	 FROM Notify  
        Order by  Hierarchy DESC'
	SELECT @Query
	EXEC (@Query)
	--EXEC up_NotifyList_Pages 
       RETURN 
    END

--   
IF @GoToPageNo = -1
BEGIN
	SELECT @DataCnt = COUNT(*) FROM Notify

	IF (@DataCnt - (@DataCnt/@MaxRows)*@MaxRows) = 0
	    SET @LastPageRows = @MaxRows
	ELSE
	    SET @LastPageRows = @DataCnt - (@DataCnt/@MaxRows)*@MaxRows

	SET @Query = '
	    SELECT  * 
	    FROM (
		SELECT TOP ' + STR(@LastPageRows) + '
			No, RootNo, Hierarchy, Lvl, Title 
		FROM  Notify
		ORDER BY RootNo ASC, Hierarchy DESC ) t
	    ORDER BY RootNo DESC, Hierarchy ASC'
    	
	EXEC (@Query)
	RETURN 
END

--   
IF @CurrentPageNo = @GotoPageNo 
BEGIN
	SET @Query = '
	SELECT TOP  ' + STR(@MaxRows) + ' No, RootNo, Hierarchy, Lvl, Title
	FROM Notify
	WHERE Hierarchy <= ''' +  @Hierarchy + '''
	Order by Hierarchy DESC'
	SELECT @Query
	 EXEC (@Query)
	RETURN 
END

--   
IF @CurrentPageNo > @GoToPageNo 
BEGIN
	SET @Query = '
	    SELECT TOP ' + STR(@MaxRows) + ' * 
	    FROM (
		SELECT TOP ' + STR(@MaxRows*(@CurrentPageNo-@GoToPageNo) + 1) +  ' 
			No,	RootNo, Hierarchy, Lvl, Title 
		FROM  Notify
		WHERE  Hierarchy > ''' + @Hierarchy + '''
		ORDER BY Hierarchy ASC) t2
	    ORDER BY Hierarchy DESC '
	SELECT @Query
	 EXEC (@Query)
        RETURN 
    END

--   
IF @CurrentPageNo < @GoToPageNo 
BEGIN
	SET @Query = '
	SELECT  * 
	FROM (
	    SELECT TOP ' + STR(@MaxRows) + ' * 
	    FROM (
		SELECT TOP ' + STR(@MaxRows*(@GoToPageNo-@CurrentPageNo+1) + 1) +  ' 
			No, RootNo, Hierarchy, Lvl, Title 
		FROM  Notify
		WHERE  Hierarchy <= ''' + @Hierarchy + '''
		ORDER BY Hierarchy DESC ) t1
	    ORDER BY Hierarchy ASC ) t2
	ORDER BY Hierarchy DESC'
    	SELECT @Query
	EXEC (@Query)
	RETURN 
END
GO

SELECT * FROM Notify ORDER BY Hierarchy DESC

EXEC up_GetNotifyList 0, 1,''
EXEC up_GetNotifyList 1, 3,'000008z'
EXEC up_GetNotifyList 3, 2,'00000101z'
EXEC up_GetNotifyList 3, -1,'00000101z'