
/********************************************************************************
Description :  Excel Ϸ ȯϴ  ν
 			   ۾    .cvs   ƾ  
Date    : 	2004.10.13
*********************************************************************************/

-- EXEC msdb.dbo.sp_delete_job @job_name ='SalesToExcel_Hong'
-- EXEC  Util_CSV_to_Excel 'Hong', 'c:\Test.csv','c:\Test.xls', 'Sales', 'SalesToExcel'

USE Pubs
GO
IF Object_ID('Util_CSV_to_Excel') IS NOT NULL
	DROP PROCEDURE Util_CSV_to_Excel
GO
CREATE  PROCEDURE Util_CSV_to_Excel
	@UserName varchar(35) ,
	@TargetName AS varchar(255),	-- .csv  
	@SaveAsName AS varchar(255),	-- ν    .xls ϸ
	@TargetTable AS varchar(255),	--.csv   ϱ  SQL Server ̺
	@JobName AS varchar(255)
AS

/* This code inserts a header row into the CSV file and
saves it as XLS for linkedserver attached
variables (you could store the script code in a table). */
DECLARE @NewJobID AS uniqueidentifier   	
DECLARE @NewJobName AS sysname
DECLARE @NewDescription AS nvarchar(512)
DECLARE @ScriptCode AS nvarchar(3200)
DECLARE @FieldCount AS integer

/* Note that the Initial Catalog in the script
could come in as a parameter if this
procedure is talking to multiple databases. */

SET @NewJobName = @JobName + '_' + @UserName
SET @NewDescription = 'Excel Temp Job FOR ' + @UserName

-- Get table schema (for header construction).
SELECT @FieldCount = count(*)
FROM information_schema.columns
WHERE table_name = @TargetTable

/* The whole script goes into this nvarchar(3200):
VBScript requires these carriage returns.
Don't use single quotes in body of script
unless you use them in pairs.
The best place to test and debug a script
is in a SQL Server Agent job step.
After testing the script, paste it here and add the necessary variables and quotes.
Set up the script code. */
SET @ScriptCode = 'Dim xlApp, xlBook, xlSheet
dim cn, rs, cmdText, t, FldName
SET xlApp = CreateObject("excel.application")
SET xlBook = xlApp.Workbooks.Open("' + @TargetName + '", 0, False, 2)
SET xlSheet = xlBook.Worksheets(1)
xlApp.DisplayAlerts = False
xlSheet.Name = "' + @TargetTable + '"
xlApp.ActiveCell.EntireRow.Insert
SET cn = CreateObject("ADODB.Connection")
SET rs = CreateObject("ADODB.Recordset")
cn.Provider = "sqloledb"
cn.Properties("Data Source").Value = "."
cn.Properties("Initial Catalog").Value = "Pubs"
cn.Properties("Integrated Security").Value = "SSPI"
cn.Open
cmdText = "SELECT table_name, column_name, ordinal_position FROM information_schema.columns WHERE table_name = ''' + @TargetTable + ''' ORDER BY ordinal_position"
rs.Open cmdText, cn
FOR t = 1 TO ' + cast(@FieldCount AS Varchar(4)) + '
	FldName = rs.Fields("column_name")
   	xlSheet.Cells(1, t).Value = FldName
   	rs.MoveNext
NEXT
rs.Close
cn.Close
xlBook.SaveAs "' + @SaveAsName + '", 43
xlBook.Close
xlApp.quit
SET rs = Nothing
SET cn = Nothing
SET xlSheet = Nothing
SET xlBook = Nothing
SET xlApp = Nothing'

-- Create job.
-- The @delete_level variable determines whether the job is permanent or temporary.
-- @delete_level 0 :    1: ۾ Ϸ  ۾   3 : ۾  ϱ  
EXEC msdb..sp_add_job @job_name=@NewJobName, @enabled=0, 
@description=@NewDescription,
@start_step_id=1, @category_name=NULL, @owner_login_name='sa', 
@notify_level_eventlog=2,
@delete_level=0, @job_id=@NewJobId output  

-- Add job server.
EXEC msdb..sp_add_jobserver @job_name=@NewJobName

-- Add job step.
EXEC msdb..sp_add_jobstep @job_name=@NewJobName, @step_id=1
	, @step_name='Create Excel File'
	, @subsystem='ActiveScripting', @command=@ScriptCode

-- Set the scripting language.
UPDATE msdb.dbo.sysjobsteps
SET database_name = 'VBScript'
WHERE job_id = @NewJobId

-- Run job.
EXEC msdb..sp_start_job @job_name= @NewJobName
GO


/********************************************************************************
Description :  SQL Server Agent ۾   Ǵϴ  ν
			 @TimeoutIn Loop Ƚ ϴ  ð ϴ ͵   
Date    : 	2004.10.13
*********************************************************************************/
IF Object_ID('Util_Is_Job_Gone') IS NOT NULL
	DROP PROC Util_Is_Job_Gone
GO

CREATE PROCEDURE Util_Is_Job_Gone
@JobName AS varchar(255),
@TimeoutIn AS integer,
@StopJob AS bit
AS

/*  ش ۾ ϴ ,  ۾     Ǿ ǴѴ.
       ۾ ִ üũѴ.
ȯ 
0 = 
1 = 
2 = ŸӾƿ / 
3 = ŸӾƿ / 

@StopJob:
0 =  
1 =   */

DECLARE @JobCount AS integer
DECLARE @JobLoop AS integer
DECLARE @LastOutcome AS integer
DECLARE @JobId AS uniqueidentifier
SET @JobCount = 1
SET @JobLoop = 1
SELECT @JobId = job_id  FROM msdb..sysjobs WHERE name = @JobName

WHILE @JobCount > 0
BEGIN
   	SELECT @JobCount = count(*) FROM msdb..sysjobs WHERE name = @JobName
   	SET @JobLoop = @JobLoop + 1
	--==============================
   	IF @JobLoop > @TimeoutIn
	--==============================
   	BEGIN
      		IF @StopJob = 1
     			BEGIN
         			-- Stop the job.

				--==============================
         			SELECT @LastOutcome = last_run_outcome 			--۾ ܰ   
				FROM msdb..sysjobsteps WHERE job_id = @JobId
				--==============================
         			EXEC msdb..sp_stop_job @job_name = @JobName
				 IF @LastOutcome = 1
					 BEGIN
					      -- The job failed.
					.              RETURN 1
					 END
				 ELSE
					 BEGIN
					     -- The job just stopped.
					      RETURN 3
					 END
			END
     		ELSE
     			BEGIN
		         	-- Let the timed-out job keep running.
				RETURN 2
			END
   	END
END

RETURN 0
GO

SELECT *  FROM msdb..sysjobs
SELECT * FROM msdb..sysjobsteps 



/********************************************************************************
Description :   SQL  ̺   ͸ ߰ϴ  ν
 
Date    : 	2004.10.13
*********************************************************************************/
--Listing 3: Stored Procedure That Inserts an Excel File into an Existing SQL Server Table
CREATE PROCEDURE Util_Excel_to_Table
@UserName varchar(255),
@JobName varchar(255),
@SourceFile varchar(255),
@TargetFile varchar(255),
@TargetTable varchar(255),
@KillMask AS varchar(255)
AS

-- local variables
DECLARE @JobLoop AS integer
DECLARE @retval AS integer
DECLARE @Bigname AS varchar(255)
DECLARE @ExcelSource AS varchar(255)
DECLARE @Worksheet AS varchar(255)
DECLARE @SQLString AS varchar(255)
DECLARE @KillCmd AS varchar(255)

-- local variable values
SET @retval = 500
SET @JobLoop = 1
SET @BigName = @JobName + '_' + @UserName
SET @ExcelSource = 'ExcelSource_' + @UserName
SET @Worksheet = @JobName + '$'
--===========================================================
SET @SQLstring = 'INSERT ' + @TargetTable + ' SELECT * FROM ' +
   @ExcelSource + '...' + @Worksheet
--===========================================================
SET @KillCmd = 'del ' + @KillMask

-- Set up the Excel file.
EXEC Util_CSV_to_Excel @UserName, @SourceFile, @TargetFile, @TargetTable, @JobName

-- See whether the job is done.
EXEC @retval = Util_Is_Job_Gone @BigName, 50000, 1

IF @retval <> 0
BEGIN
   -- Return error and exit (in stored procedure).
   -- Most other errors are nonfatal.
   RETURN @retval
END

-- Create the link.
EXEC sp_addlinkedserver @ExcelSource, 'Jet 4.0', 'Microsoft.Jet.OLEDB.4.0',
@TargetFile, NULL, 'Excel 5.0'
EXEC sp_addlinkedsrvlogin @ExcelSource, 'false', 'sa', 'Admin', NULL

-- Load from the link to the table.
EXEC (@SQLString)

-- Break the link.
EXEC sp_dropserver @ExcelSource, 'droplogins'

-- Delete the files.
EXEC master.dbo.xp_cmdshell @KillCmd, no_output

-- Report success.
RETURN 0
GO

/*
SELECT *
FROM OpenDataSource( 'Microsoft.Jet.OLEDB.4.0',
  'Data Source="C:\INBREINWDDrive\̳\MCPWorld\ڷ\Test.xls";User ID=Admin;Password=;Extended properties=Excel 5.0')...ڳʺ$
*/
